#! /usr/bin/env python3
#
# About program:
# Simple password generator
# Program for generate passwords
__version__ = '1.0'
__author__ = 'Karpukhin Pavel <---my@mail.com--->'
__license__ = 'Public Domain'
#__url__ = 'http://---.ru'
#

# Import needed modules
import secrets
import os
import math
import locale
from os import system
from os import name
import subprocess
#####


# Script colorization (by os.name)
class TxtColors:
    # for Windows
    if name == 'nt':
        ColorEND = ''
        ColorRED = ''
        ColorGREEN = ''
        ColorYELLOW = ''
        ColorBLUEBG = ''
        ColorWHITE = ''
        ColorREDBG = ''
        ColorGREENBG = ''
    # for Linux
    else:
        ColorEND = '\33[0m'
        ColorRED = '\33[31m'
        ColorGREEN = '\33[32m'
        ColorYELLOW = '\33[33m'
        ColorBLUEBG = '\33[44m'
        ColorWHITE = '\33[37m'
        ColorREDBG = '\33[37;41m'
        ColorGREENBG = '\33[30;42m'


# Clear screen (by os.name)
def clear():
    # for Windows
    if name == 'nt':
        _ = system('cls')
    # for Linux
    else:
        _ = system('clear')


# Get system locale
locale.setlocale(locale.LC_ALL, "")
if name == 'nt':
    sys_locale = locale.getlocale()[0]
else:
    sys_locale = locale.getlocale(locale.LC_MESSAGES)[0]


# Localization programm (by OS locale)
class TxtLocales:
    # for Linux Russian language
    if sys_locale == 'ru_RU':
        TextMessage01 = 'Генератор простых паролей'
        TextMessage02 = 'Хотите повторить? [Yes | No]: \n'
        TextMessage03 = 'Сколько паролей вы планируете сгенерировать? '
        TextMessage04 = '\nВводите только цифры.\nРабота завершена.'
        TextMessage05 = 'Из скольких символов сгенерировать пароль? '
        TextMessage06 = 'Нехватает данных для расчёта...'
        TextMessage07 = 'Запрошено паролей - '
        TextMessage08 = 'Длина в символах  - '
        TextMessage09 = 'Предлагаю следующие варианты: \n'
        TextMessage10 = 'Заходите ещё,'
        TextMessage11 = 'всегда рад помочь. =)\n'
        TextMessage12 = 'Вариант №'
        TextMessage13 = 'Хотите назначить данному пользователю указанный пароль? [Yes | No] '
        TextMessage14 = 'Выберите вариант пароля из предложенных ранее [1,2,3,etc]: '
        TextMessage15 = 'Укажите логин пользователя: '
        TextMessage16 = 'Пароль с таким порядковым номером не генерировался.'
        TextMessage17 = '\nОтлично, для пользователя: '
        TextMessage18 = ' вы выбрали пароль: '
        TextMessage19 = 'Выполнено.\n'
        TextMessage20 = 'Отмена операции. Вы выбрали пункт [No]'
        TextMessage21 = 'Хотите назначить пароль пользователю сейчас? [Yes | No] '
        TextMessage22 = 'Затребована только генерация паролей, назначение пользователю не востребовано.'
    # For Windows Russian language
    elif sys_locale == 'Russian_Russia':
        TextMessage01 = 'Генератор простых паролей'
        TextMessage02 = 'Хотите повторить? [Yes | No]: \n'
        TextMessage03 = 'Сколько паролей вы планируете сгенерировать? '
        TextMessage04 = '\nВводите только цифры.\nРабота завершена.'
        TextMessage05 = 'Из скольких символов сгенерировать пароль? '
        TextMessage06 = 'Нехватает данных для расчёта...'
        TextMessage07 = 'Запрошено паролей - '
        TextMessage08 = 'Длина в символах  - '
        TextMessage09 = 'Предлагаю следующие варианты: \n'
        TextMessage10 = 'Заходите ещё,'
        TextMessage11 = 'всегда рад помочь. =)\n'
        TextMessage12 = 'Вариант №'
        TextMessage13 = 'Хотите назначить данному пользователю указанный пароль? [Yes | No] '
        TextMessage14 = 'Выберите вариант пароля из предложенных ранее [1,2,3,etc]: '
        TextMessage15 = 'Укажите логин пользователя: '
        TextMessage16 = 'Пароль с таким порядковым номером не генерировался.'
        TextMessage17 = '\nОтлично, для пользователя: '
        TextMessage18 = ' вы выбрали пароль: '
        TextMessage19 = 'Выполнено.\n'
        TextMessage20 = 'Отмена операции. Вы выбрали пункт [No]'
        TextMessage21 = 'Хотите назначить пароль пользователю сейчас? [Yes | No] '
        TextMessage22 = 'Затребована только генерация паролей, назначение пользователю не востребовано.'
    # for Other languages
    else:
        TextMessage01 = 'Simple password generator'
        TextMessage02 = 'Are you want repeat? [Yes | No]: \n'
        TextMessage03 = 'How many passwords generate for you? '
        TextMessage04 = '\nUse only digits.\nProgramm closed by input error.'
        TextMessage05 = 'How many chracters to use to generate a password? '
        TextMessage06 = 'There is not enough data for calculation...'
        TextMessage07 = 'Password requested - '
        TextMessage08 = 'Length in characters - '
        TextMessage09 = 'I suggest the following variants: \n'
        TextMessage10 = '\nYou are welcome.'
        TextMessage11 = 'Come again! '
        TextMessage12 = 'Variant #'
        TextMessage13 = 'You want to assign this user a specified password? [Yes | No] '
        TextMessage14 = 'Select a password option from those suggested earlier [1,2,3,etc]:'
        TextMessage15 = 'Specify user login:'
        TextMessage16 = 'Password number out of range'
        TextMessage17 = '\nOk, for user: '
        TextMessage18 = ' you choose password: '
        TextMessage19 = 'Done.\n'
        TextMessage20 = 'Cancellation. You choose [No]'
        TextMessage21 = 'Do you want to assign a password to the user now? [Yes | No]'
        TextMessage22 = 'Only password generation is required, assignment to a user is not required.'


# Print program name
def program_name():
    print(TxtColors.ColorBLUEBG + TxtLocales.TextMessage01 + TxtColors.ColorEND + '\n')


# Rerun program
def replay():
    return input(TxtLocales.TextMessage02).lower().startswith('y')


# Rerun program
def rearmuser():
    return input(TxtLocales.TextMessage13).lower().startswith('y')


# Number of passwords
def pwd_count():
    pwds = 0
    pwd_massive = list(range(1,100))
    try:
        while int(pwds) not in pwd_massive:
            pwds = input(TxtLocales.TextMessage03)
    except ValueError:
        print(TxtColors.ColorRED + TxtLocales.TextMessage04 + TxtColors.ColorEND)
        exit()
    else:
        return int(pwds)


# Number of characters in password
def pwd_chars():
    chrs = 0
    chr_massive = list(range(1,50))
    try:
        while int(chrs) not in chr_massive:
            chrs = input(TxtLocales.TextMessage05)
    except ValueError:
        print(TxtColors.ColorRED + TxtLocales.TextMessage04 + TxtColors.ColorEND)
        exit()
    else:
        return int(chrs)


def genpwrds(chrs):
    if chrs > 0:
        # token_urlsafe use bytes in Bsae64 encoding. 1 byte is 1.3 character.
        password = secrets.token_urlsafe(chrs)
    else:
        password = TxtLocales.TextMessage06
    return str(password)


def userinppass():
    pnum = input(TxtLocales.TextMessage14)
    return int(pnum)


def userinpname():
    pname = input(TxtLocales.TextMessage15)
    return (pname)


def userinpchahge():
    return input(TxtLocales.TextMessage21).lower().startswith('y')


while True:
    # Clear screen and start program
    clear()
    program_name()
    game_on = True
    i = 1
    count_passwords_view = pwd_count()
    count_passwords = count_passwords_view + 1
    count_chars =  pwd_chars()
    password_arr = []

    while game_on:
        clear()
        program_name()
        print(TxtLocales.TextMessage07 + TxtColors.ColorYELLOW + str(count_passwords_view) + TxtColors.ColorEND)
        print(TxtLocales.TextMessage08 + TxtColors.ColorYELLOW + str(count_chars) + TxtColors.ColorEND)
        print('===================================\n')
        print(TxtLocales.TextMessage09)
        for i in range(i, count_passwords, 1):
            generated_password = genpwrds(count_chars)
            generated_password2 = str(generated_password[-count_chars:])
            print(TxtLocales.TextMessage12 + str(i) + ': ' + TxtColors.ColorGREEN + generated_password2 + TxtColors.ColorEND)
            password_arr.append(generated_password2)
                        
            game_on = False
        print('===================================\n')
        #print(password_arr)
        if name != 'nt':
            if userinpchahge():
                pass_num = userinppass()
                pass_number = pass_num - 1
                
                if ( 0 < pass_num < count_passwords ):
                    pass_for_user = password_arr[pass_number]
                else:
                    print (TxtColors.ColorREDBG + TxtLocales.TextMessage16 + TxtColors.ColorEND)
                    break
                
                user_name = userinpname()
                
                print (TxtLocales.TextMessage17 + TxtColors.ColorYELLOW + user_name + TxtColors.ColorEND + TxtLocales.TextMessage18 + TxtColors.ColorYELLOW + pass_for_user + TxtColors.ColorEND )
                if rearmuser():
                    my_proc = subprocess.getoutput("echo " + user_name + ":" + pass_for_user + " | chpasswd " )
                    my_result = my_proc
                    if (my_result == ""):
                        print (TxtColors.ColorGREENBG + TxtLocales.TextMessage19 + TxtColors.ColorEND)
                    else:
                        print (TxtColors.ColorREDBG + my_result + TxtColors.ColorEND)
                else:
                    print (TxtColors.ColorREDBG + TxtLocales.TextMessage20 + TxtColors.ColorEND)
            else:
                print (TxtColors.ColorREDBG + TxtLocales.TextMessage22 + TxtColors.ColorEND)
        else: None
            
    if not replay():
        print(TxtLocales.TextMessage10)
        print(TxtLocales.TextMessage11)
        break
